Subject: RE: bug#16513: 24.3.50; doc string of `use-empty-active-region'

From: Drew Adams <[email-masked]>
Date: Fri, 29 Apr 2016 11:20:07 -0700 (PDT)

> > 1. Remove the last part: ", and on the text near point otherwise."  It
> > is inappropriate and wrong.  (This is the reason I filed this bug.)
> >
> > This is about commands that act differently depending on whether or
> > not the region is active.  Do not say anything about what the behavior
> > must be in either case: active or inactive.  Certainly, do not claim
> > that when the region is inactive such commands act on the text near
> > point. That is pure fantasy.
> 
> I think I understand what Chong was trying to express here now.
> 
> ---
> Region-aware commands are those that act on the region if it is
> active and Transient Mark mode is enabled, and on the text near
> point otherwise.
> ---
> 
> This explains the concept of "region-aware" commands -- they typically
> switch between acting on the stuff around point and the stuff in the
> region.  Like `DEL', which deletes the region if it is active, and the
> previous character if not.
> 
> So I don't think it's wrong...

It is wrong.  What is correct is that region-aware commands act
on the region when it is active.  What is 100% wrong (though it
could be right for some command, of course) is to say anything
about the behavior when the region is not active.

It is just not true in general that when the region is not
active the command acts on text near point.  That is pure
invention.  NOTHING makes that happen.  A region-aware command
can do anything at all when the region is not active.

What could reasonably be said, perhaps, is that in general
such commands do something similar but to some other text,
not necessarily to the region text.  And in practice, such
commands (those that are predefined by Emacs, in any case)
typically act on the entire accessible portion of the buffer
(i.e., the whole buffer or its current restriction (narrowing)).

But certainly not some text near point.

> > 2. Simplify the following, which suggests that having an active region
> > is somehow different from having an active mark:
> >
> > "If non-nil, region-aware commands treat the region as active as long as
> > the mark is active, even if the region is empty."  Just say: "If
> > non-nil, region-aware commands treat an active region as such, even if
> > it is empty."
> 
> No, I like the mention of the mark, which helps my understanding of what
> it's saying.

It suggests that having an active region is somehow different
from having an active mark.  Instead, it would help to say
explicitly that they are the same thing: when the mark is
active so is the region, and vice versa.